> For the complete documentation index, see [llms.txt](https://docs.pinot.apache.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pinot.apache.org/functions/json/jsonkeyvaluearraytomap.md).

# JSONKEYVALUEARRAYTOMAP

This section contains reference documentation for the JSONKEYVALUEARRAYTOMAP function.

Converts an array of objects into a map. By default, Pinot reads the `key` field as the map key and the `value` field as the map value. This function can be used in an [ingestion transformation function](/build-with-pinot/ingestion/transformations-and-aggregations/ingestion-level-transformations.md).

## Signature

> JSONKEYVALUEARRAYTOMAP(keyValueArray, \[keyColumnName], \[valueColumnName])

| Arguments         | Description                                                       |
| ----------------- | ----------------------------------------------------------------- |
| `keyValueArray`   | An **Identifier**/**Expression** containing an array of objects.  |
| `keyColumnName`   | Optional field name to use as the map key. Defaults to `key`.     |
| `valueColumnName` | Optional field name to use as the map value. Defaults to `value`. |

## Usage Examples

```json
[
  {"key": "k1", "value": "v1"},
  {"key": "k2", "value": "v2"},
  {"key": "k3", "value": "v3"}
]
```

| Expression                                      | Value                             |
| ----------------------------------------------- | --------------------------------- |
| `JSONKEYVALUEARRAYTOMAP(input)`                 | `{"k1":"v1","k2":"v2","k3":"v3"}` |
| `JSONKEYVALUEARRAYTOMAP(input, 'key', 'value')` | `{"k1":"v1","k2":"v2","k3":"v3"}` |

This function can be used in the [table config](/reference/configuration-reference/table.md) to materialize a `MAP` column during ingestion:

```json
{
  "tableConfig": {
    "ingestionConfig": {
      "transformConfigs": [
        {
          "columnName": "attributes",
          "transformFunction": "JSONKEYVALUEARRAYTOMAP(rawAttributes)"
        }
      ]
    }
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.pinot.apache.org/functions/json/jsonkeyvaluearraytomap.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
